global function flow_init
global function AddMeterFromDamage
global function RegisterMeterGainFromKill


//////////////////
//settings begin//
//////////////////
struct{ //make your changes here:
    vector barPosition = Vector(0.86, 0.24, 0.0)//x axis: 0.0 is max left, 1.0 is max right; y axis: 0.0 is max top, 1.0 is max down; z doesn't do anything
    float barAlpha = 0.7 //alpha of the text (progress bar to the next tier), range: 0.0 to 1.0
    float barSize = 36.0 //size of the text
	vector gradePosition = Vector(0.93, 0.17, 0.0) //position of the grade
	float gradeAlpha = 0.9 //alpha of the grade
	float gradeSize = 60.0 //size of the grade
	float gradeThicc = 0.25 //determines how thicc the grade is
	vector plusSthColour = Vector(0.6,0.6,0.6) //colour of +sth
	float plusSthAlpha = 0.7 //alpha of +sth
	vector barSthOffset = Vector(0.0,0.035,0.0) //distance between the lines of text and the bar, probably needs readjusting if you modify bar size
	
	float gainTendency = 0.0004 //tempo of gaining meter from speed, should be kept below 0.01
	float lossTendency = 0.013 //tempo of losing meter
	float minMaintainSpeed = 30 //minimum speed [kph] needed to maintain meter at 0% meter
	float minGainSpeed = 35 //minimum speed [kph] needed to gain meter at 0% meter
	float maxMaintainSpeed = 45 //minimum speed [kph] needed to maintain meter at 100% meter
	float maxGainSpeed =  50 //minimum speed [kph] needed to gain meter at 100% meter
	//I've set these default values by trial and error, they seemed to work well enough for me
	//please be reasonable while setting these values, it is probably really easy to break it
	
} settingsF

//some more settings
global const float pilotDamageGainTendency = 0.09 //determines how much meter pilot damage adds
global const float titanDamageGainTendency = 0.006 //determines how much meter titan damage adds
global const float pilotVsTitanMultiplier = 0.06 //added on top of pvp
global const float titanVsPilotMultiplier = 12 //added on top of tvt
global const float critGainTendency = 1.5 //crit meter multiplier (crits have different damage multipliers per weapon)
global const float baseKillMeterValue = 5 //determines how much meter you gain from kills
global const int meter_ringBufferSize = 16 //please don't touch this unless you know how it works
////////////////
//settings end//
////////////////

//This structure is used to send data between function, indexes are used to avoid losing damage data
struct {
	float[meter_ringBufferSize] meterGainSamples
	int readIndex = 0
	int writeIndex = 0
} meterDamageGainData

struct {
	float[meter_ringBufferSize] meterGainSamples
	int readIndex = 0
	int writeIndex = 0
} meterKillGainData


void function flow_init()
{
	AddLocalPlayerDidDamageCallback( RegisterMeterGainFromKill )
	thread flowMeterUI()
}


var flowRUI = null
var gradeRUI = null
array < var > plusRUIs = [null, null, null, null, null]

void function flowMeterUI()
{
	WaitFrame()
	//This RUI is responsible for the progress bar
    flowRUI = RuiCreate( $"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1 )
	RuiSetInt(flowRUI, "maxLines", 1)
	RuiSetInt(flowRUI, "lineNum", 1)
	RuiSetFloat2(flowRUI, "msgPos", settingsF.barPosition)
	RuiSetString(flowRUI, "msgText", "")
	RuiSetFloat(flowRUI, "msgFontSize", settingsF.barSize)
	RuiSetFloat(flowRUI, "msgAlpha", settingsF.barAlpha)
	RuiSetFloat(flowRUI, "thicken", 0.0)
	RuiSetFloat3(flowRUI, "msgColor", Vector(0.0,0.0,1.0))
	
	for(int j = 0; j < 5; j++) //5 ruis for the +sth
	{
	plusRUIs[j] = RuiCreate( $"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1 )
	RuiSetInt(plusRUIs[j], "maxLines", 1)
	RuiSetInt(plusRUIs[j], "lineNum", 1)
	RuiSetFloat2(plusRUIs[j], "msgPos", settingsF.barPosition + settingsF.barSthOffset*(j+1))
	RuiSetString(plusRUIs[j], "msgText", "")
	RuiSetFloat(plusRUIs[j], "msgFontSize", settingsF.barSize)
	RuiSetFloat(plusRUIs[j], "msgAlpha", settingsF.plusSthAlpha)
	RuiSetFloat(plusRUIs[j], "thicken", 0.0)
	RuiSetFloat3(plusRUIs[j], "msgColor", settingsF.plusSthColour)
	}
	
	//Additional RUI placed here, for printing grades
	gradeRUI = RuiCreate( $"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1 )
	RuiSetInt(gradeRUI, "maxLines", 1)
	RuiSetInt(gradeRUI, "lineNum", 1)
	RuiSetFloat2(gradeRUI, "msgPos", settingsF.gradePosition)
	RuiSetString(gradeRUI, "msgText", "")
	RuiSetFloat(gradeRUI, "msgFontSize", settingsF.gradeSize)
	RuiSetFloat(gradeRUI, "msgAlpha", settingsF.gradeAlpha)
	RuiSetFloat(gradeRUI, "thicken", settingsF.gradeThicc)
	RuiSetFloat3(gradeRUI, "msgColor", Vector(0.0,0.0,1.0))
	thread flowMeter()
	//Important thing about these, the default values are visible when inspecting titans before joining mp match, so i'm changimg the default strings to empty ones
}


void function flowMeter()
{
	float maxMeter = 100;
	float currentMeter = 0;
	float displayedMeter = 0;
	
	float maxMaintainSpeedTendency = (settingsF.maxMaintainSpeed-settingsF.minMaintainSpeed)/maxMeter
	float maxGainSpeedTendency = (settingsF.maxGainSpeed-settingsF.minGainSpeed)/maxMeter
	
	float lastTime = Time();
	float dt = 1;
	float timeSinceGainOrMaintain = 0;
	float timeSinceSpeedGain = 3.5
	float timeSinceDamageGain = 3.5
	float timeSinceKillGain = 10.5
	float continuousMovementTime = 0
	int currentKillstreak = 0
	
	string meterString = "";
	string gradeString = ""
	int currentGradeBars = 0;
	float calculatedGradeBarValue = 0;
	float totalDamageMeterGain = 0
	
	//changes
	int[5] plusSthMessageTypes = [0,0,0,0,0] // Values: 0 - empty, 1 - speed, 2 - damage, 3 - movement, 4 - kill, 5 - killstreak
	string[5] plusSthMessages = ["","","","",""]
	//with this method, I set messages first, and then print them
	
	//AddCallback_OnPlayerKilled(RegisterMeterGainFromKill) //this was used before 1.1.5
	
    while(true){
        WaitFrame()
        if(!IsLobby()){ //speedometer code
            entity player = GetLocalViewPlayer()
            if (player == null || !IsValid(player))
			    continue
            vector playerVelV = player.GetVelocity()
            float playerVel
            playerVel = sqrt(playerVelV.x * playerVelV.x + playerVelV.y * playerVelV.y)
            float playerVelNormal = playerVel * (0.274176/3) //here is our speed
			
		
			dt = Time() - lastTime; //two lines from Provoxin's RGB mod
			lastTime = Time();	
			timeSinceDamageGain += dt
			timeSinceSpeedGain += dt
			timeSinceKillGain += dt
			
			//meter calculation:
			if(playerVelNormal > settingsF.minGainSpeed + currentMeter*maxGainSpeedTendency) //this section calculates the gain or loss of meter based on it's current value and your speed
			{
				if(continuousMovementTime < 7)
				{
				currentMeter += dt * playerVelNormal * settingsF.gainTendency * (1.05*maxMeter - currentMeter);
				
				RuiSetString(plusRUIs[2], "msgText", "")
				}
				else if(continuousMovementTime < 15)
				{
				currentMeter += dt * playerVelNormal * settingsF.gainTendency * (1.05*maxMeter - currentMeter)*1.5;
				
				plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 3)] = "+movement"
				}
				else if(continuousMovementTime < 25)
				{
				currentMeter += dt * playerVelNormal * settingsF.gainTendency * (1.05*maxMeter - currentMeter)*2;
				
				plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 3)] = "+good movement"
				}
				else
				{
				currentMeter += dt * playerVelNormal * settingsF.gainTendency * (1.05*maxMeter - currentMeter)*2.5;
				
				plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 3)] = "+great movement"
				}
				timeSinceGainOrMaintain = 0
				timeSinceSpeedGain = 0
				continuousMovementTime += dt
			}
			else if(playerVelNormal > settingsF.minMaintainSpeed + currentMeter*maxMaintainSpeedTendency)
			{
				timeSinceGainOrMaintain = 0
				continuousMovementTime += dt
			}
			else
			{
				timeSinceGainOrMaintain += dt
				if(timeSinceGainOrMaintain>2){
				currentMeter -= sqrt(timeSinceGainOrMaintain) * settingsF.lossTendency
				}
				continuousMovementTime = 0
				
				removeTextFromPlusSth(plusSthMessages, plusSthMessageTypes, 3)
			}
			
			
			while(meterDamageGainData.readIndex != meterDamageGainData.writeIndex) //damage gain
			{
				currentMeter += meterDamageGainData.meterGainSamples[meterDamageGainData.readIndex] * (3*maxMeter-2*currentMeter)/300 
				totalDamageMeterGain += meterDamageGainData.meterGainSamples[meterDamageGainData.readIndex] * (3*maxMeter-2*currentMeter)/300
				meterDamageGainData.readIndex = (meterDamageGainData.readIndex + 1)%meter_ringBufferSize
				timeSinceGainOrMaintain = 0
				timeSinceDamageGain = 0
			}
			
			while(meterKillGainData.readIndex != meterKillGainData.writeIndex) //kill gain
			{
				currentKillstreak++
				if(currentKillstreak < 4)
				{
					currentMeter += meterKillGainData.meterGainSamples[meterKillGainData.readIndex] * (2*maxMeter-currentMeter)/200
					meterKillGainData.readIndex = (meterKillGainData.readIndex + 1)%meter_ringBufferSize
				}
				else if(currentKillstreak < 9)
				{
					currentMeter += meterKillGainData.meterGainSamples[meterKillGainData.readIndex] * (2*maxMeter-currentMeter)/200 * (1 + (currentKillstreak - 3) * 0.2)
					meterKillGainData.readIndex = (meterKillGainData.readIndex + 1)%meter_ringBufferSize
				}
				else
				{
					currentMeter += meterKillGainData.meterGainSamples[meterKillGainData.readIndex] * (2*maxMeter-currentMeter)/200 * 2
					meterKillGainData.readIndex = (meterKillGainData.readIndex + 1)%meter_ringBufferSize
				}	
				
				timeSinceKillGain = 0
			}
			
			
			//I don't want to mess with values which do not fit into the meter
			if(currentMeter > 100)
			currentMeter = 100;
			else if(currentMeter < 0)
			currentMeter = 0;
			
			//next section is for displaying the meter
			
			if(!IsAlive(GetLocalClientPlayer())) //for resetting meter upon respawn or death
			{
				currentMeter = 0;
				currentKillstreak = 0
				timeSinceDamageGain = 10
				timeSinceGainOrMaintain = 10
				timeSinceKillGain = 10
				timeSinceSpeedGain = 10
			}
			

			//Here we prepare the grade and progress bar
			int currentGradeBars = 0
			meterString = ""
			
			//by default the length of the bar should be 16 max, eg. 40/0.625
			
			if(currentMeter < 20)
			{
				gradeString = " "
				calculatedGradeBarValue = currentMeter/1.25
				currentGradeBars = calculatedGradeBarValue.tointeger()
				for(int i = 0 ; i < currentGradeBars ; i++) //there has to be a better way to make a "progress bar", but I have no clue how
				{
				meterString += "|"
				}
				RuiSetString(flowRUI, "msgText", meterString) //setting text
				RuiSetString(gradeRUI, "msgText", gradeString)
				RuiSetFloat3(flowRUI, "msgColor", Vector(0.5,0.5,0.5)+ Vector(-0.05, -0.05, 0.05)*currentGradeBars) //setting colour
				RuiSetFloat3(gradeRUI, "msgColor", Vector(0.5,0.5,0.5)+ Vector(-0.05, -0.05, 0.05)*currentGradeBars)
			}
			else if(currentMeter < 38)
			{
				gradeString = "E"
				calculatedGradeBarValue = (currentMeter - 20)/1.125
				currentGradeBars = calculatedGradeBarValue.tointeger()
				for(int i = 0 ; i < currentGradeBars ; i++)
				{
				meterString += "|"
				}
				RuiSetString(flowRUI, "msgText", meterString)
				RuiSetString(gradeRUI, "msgText", gradeString)
				RuiSetFloat3(flowRUI, "msgColor", Vector(0.0,0.0,1.0)+ Vector(0.0, 0.1, 0.0)*currentGradeBars)
				RuiSetFloat3(gradeRUI, "msgColor", Vector(0.0,0.0,1.0)+ Vector(0.0, 0.1, 0.0)*currentGradeBars)
			}
			else if(currentMeter < 54)
			{
				gradeString = "D"
				calculatedGradeBarValue = (currentMeter - 38)
				currentGradeBars = calculatedGradeBarValue.tointeger()
				for(int i = 0 ; i < currentGradeBars ; i++)
				{
				meterString += "|"
				}
				RuiSetString(flowRUI, "msgText", meterString)
				RuiSetString(gradeRUI, "msgText", gradeString)
				RuiSetFloat3(flowRUI, "msgColor", Vector(0.0,1.0,1.0)+ Vector(0.0, 0.0, -0.1)*currentGradeBars)
				RuiSetFloat3(gradeRUI, "msgColor", Vector(0.0,1.0,1.0)+ Vector(0.0, 0.0, -0.1)*currentGradeBars)
			}
			else if(currentMeter < 68)
			{
				gradeString = "C"
				calculatedGradeBarValue = (currentMeter - 54)/0.875
				currentGradeBars = calculatedGradeBarValue.tointeger()
				for(int i = 0 ; i < currentGradeBars ; i++)
				{
				meterString += "|"
				}
				RuiSetString(flowRUI, "msgText", meterString)
				RuiSetString(gradeRUI, "msgText", gradeString)
				RuiSetFloat3(flowRUI, "msgColor", Vector(0.0,1.0,0.0)+ Vector(0.1, 0.0, 0.0)*currentGradeBars)
				RuiSetFloat3(gradeRUI, "msgColor", Vector(0.0,1.0,0.0)+ Vector(0.1, 0.0, 0.0)*currentGradeBars)
			}
			else if(currentMeter < 80)
			{
				gradeString = "B"
				calculatedGradeBarValue = (currentMeter - 68)/0.75
				currentGradeBars = calculatedGradeBarValue.tointeger()
				for(int i = 0 ; i < currentGradeBars ; i++)
				{
				meterString += "|"
				}
				RuiSetString(flowRUI, "msgText", meterString)
				RuiSetString(gradeRUI, "msgText", gradeString)
				RuiSetFloat3(flowRUI, "msgColor", Vector(1.0,1.0,0.0)+ Vector(0.0, -0.05, 0.0)*currentGradeBars)
				RuiSetFloat3(gradeRUI, "msgColor", Vector(1.0,1.0,0.0)+ Vector(0.0, -0.05, 0.0)*currentGradeBars)
			}
			else if(currentMeter < 90)
			{
				gradeString = "A"
				calculatedGradeBarValue = (currentMeter - 80)/0.625
				currentGradeBars = calculatedGradeBarValue.tointeger()
				for(int i = 0 ; i < currentGradeBars ; i++)
				{
				meterString += "|"
				}
				RuiSetString(flowRUI, "msgText", meterString)
				RuiSetString(gradeRUI, "msgText", gradeString)
				RuiSetFloat3(flowRUI, "msgColor", Vector(1.0,0.5,0.0)+ Vector(0.0, -0.05, 0.0)*currentGradeBars)
				RuiSetFloat3(gradeRUI, "msgColor", Vector(1.0,0.5,0.0)+ Vector(0.0, -0.05, 0.0)*currentGradeBars)
			}
			else
			{
				gradeString = "S"
				calculatedGradeBarValue = (currentMeter - 90)/0.625
				currentGradeBars = calculatedGradeBarValue.tointeger()
				for(int i = 0 ; i < currentGradeBars ; i++)
				{
				meterString += "|"
				}
				RuiSetString(flowRUI, "msgText", meterString)
				RuiSetString(gradeRUI, "msgText", gradeString)
				RuiSetFloat3(flowRUI, "msgColor", Vector(1.0,0.0,0.0))
				RuiSetFloat3(gradeRUI, "msgColor", Vector(1.0,0.0,0.0))
			}
			
			if(playerVelNormal > settingsF.minGainSpeed + currentMeter*maxGainSpeedTendency)
			{
				//+speed
				
				plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 1)] = "+speed"
				if(playerVelNormal > 45)
				{
					plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 1)] = "+good speed"
				}
				if(playerVelNormal > 55)
				{
					plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 1)] = "+great speed"
				}
				if(playerVelNormal > 70)
				{
					plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 1)] = "+speed demon"
				}
			}
			else if(timeSinceSpeedGain > 2)
			{
				removeTextFromPlusSth(plusSthMessages, plusSthMessageTypes, 1)
			}
			
			//+damage
			if(totalDamageMeterGain != 0 && timeSinceDamageGain < 3)
			{
				if(totalDamageMeterGain < 20)
				{
					plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 2)] = "+damage"
				}
				else if(totalDamageMeterGain < 40)
				{
					plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 2)] = "+good damage"
				}
				else if(totalDamageMeterGain < 60)
				{
					plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 2)] = "+great damage"
				}
				else
				{
					plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 2)] = "+bloodshed"
				}
			}
			else
			{
				totalDamageMeterGain = 0
				removeTextFromPlusSth(plusSthMessages, plusSthMessageTypes, 2)
			}
			
			//+kill
			if(timeSinceKillGain < 3)
			{
				plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 4)] = "+kill"
			}
			else
			{
				removeTextFromPlusSth(plusSthMessages, plusSthMessageTypes, 4)
			}
			
			//+killstreak
			if(timeSinceKillGain > 10)
			{
				currentKillstreak = 0
				removeTextFromPlusSth(plusSthMessages, plusSthMessageTypes, 5)
			}
			else if(currentKillstreak > 2)
			{
				plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 5)] = "+killstreak x" + currentKillstreak.tostring()
			}
			
			if(!IsAlive(GetLocalClientPlayer())) //for resetting meter upon respawn or death
			{
				foreach(mes in plusSthMessages)
				{
					mes = ""
				}
			}
			
			printRuiPlusSthMessages(plusRUIs, plusSthMessages)
			
		}
	}
}




void function RegisterMeterGainFromKill( entity attacker, entity victim, vector damagePos, int damageType )
{
	if(attacker == GetLocalClientPlayer())
	{
		if(damageType & DF_KILLSHOT && victim.IsPlayer() || damageType & DF_KILLSHOT && victim.IsTitan())
		{
			meterKillGainData.meterGainSamples[meterKillGainData.writeIndex] = baseKillMeterValue
			meterKillGainData.writeIndex = (meterKillGainData.writeIndex + 1)%meter_ringBufferSize
			
			//Logger.Info("Kill")
		}
	}
}


void function AddMeterFromDamage( float damage, bool isCrit, entity victim){ //this function calculates meter gain from damage
	entity player = GetLocalViewPlayer()
	float actualValue = damage
	if(victim.IsPlayer()){ //vs players
	if(!player.IsTitan() && !victim.IsTitan()) //pilot v pilot gain
	{
		
		if(damage > 100)
		{
			actualValue = 100
		}
		else
		{
			actualValue = damage
		}
		
		if(isCrit)
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = actualValue * pilotDamageGainTendency * critGainTendency
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
		else
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = actualValue * pilotDamageGainTendency
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
	}
	else if(player.IsTitan() && victim.IsTitan())//titan v titan gain
	{
		if(isCrit)
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = damage * titanDamageGainTendency * critGainTendency
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
		else
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = damage * titanDamageGainTendency
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
	}
	else if(!player.IsTitan() && victim.IsTitan()) //pilot v titan gain
	{
		if(isCrit)
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = damage * pilotDamageGainTendency * critGainTendency * pilotVsTitanMultiplier
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
		else
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = damage * pilotDamageGainTendency * pilotVsTitanMultiplier
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
	}
	
	else //titan v pilot gain
	{
		if(damage > 100)
		{
			actualValue = 100
		}
		else
		{
			actualValue = damage
		}
		if(isCrit)
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = actualValue * titanDamageGainTendency * critGainTendency * titanVsPilotMultiplier
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
		else
		{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = actualValue * titanDamageGainTendency * titanVsPilotMultiplier
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
		}
	}
	}
	else //vs AI or something
	{
	if(!player.IsTitan() || victim.IsTitan()) 
	{
		meterDamageGainData.meterGainSamples[meterDamageGainData.writeIndex] = damage * titanDamageGainTendency
		meterDamageGainData.writeIndex = (meterDamageGainData.writeIndex + 1)%meter_ringBufferSize
	}
	}
}

/*
void function RegisterMeterGainFromKill(entity victim, entity attacker, int damageSourceId) //this function relies on kill callback, needed for versions prior to 1.1.5
{
	if(attacker == GetLocalClientPlayer() && !victim.IsTitan())
	{
		meterKillGainData.meterGainSamples[meterKillGainData.writeIndex] = baseKillMeterValue
		meterKillGainData.writeIndex = (meterKillGainData.writeIndex + 1)%meter_ringBufferSize
	}
	
}
*/

//example use of functions below:
//int speedLocation = findPlaceForMessageInTable(plusSthMessageTypes, 1)
//plusSthMessages[speedLocation] = "+speed"

//plusSthMessages[findPlaceForMessageInTable(plusSthMessageTypes, 3)] = "+movement"

//removeTextFromPlusSth(plusSthMessages, plusSthMessageTypes, 3)

int function findPlaceForMessageInTable(int[5] plusSthMessageTypes, int messageType)
{
	for(int currentMessageIndex = 0; currentMessageIndex < 5; currentMessageIndex++)
	{
		if(plusSthMessageTypes[currentMessageIndex] == 0 || plusSthMessageTypes[currentMessageIndex] == messageType)
		{
			plusSthMessageTypes[currentMessageIndex] = messageType
			return currentMessageIndex
		}
	}
	return 4
}


void function removeTextFromPlusSth(string[5] messages, int[5] plusSthMessageTypes, int messageType)
{
	for(int currentMessageIndex = 0; currentMessageIndex < 5; currentMessageIndex++)
	{
		if(plusSthMessageTypes[currentMessageIndex] == messageType)
		{
			int temp = currentMessageIndex
			while(temp < 4)//shift the messages, so that the space is freed at the bottom
			{
				plusSthMessageTypes[temp] = plusSthMessageTypes[temp+1]
				messages[temp] = messages[temp+1]
				temp++
			}
			temp = 0
			plusSthMessageTypes[4] = 0
			messages[4] = ""
		}
	}
}


void function printRuiPlusSthMessages(array < var > plusRUIs, string[5] messages)
{
	for(int i = 0; i < 5; i++)
	{
		RuiSetString(plusRUIs[i], "msgText", messages[i])
	}
}


//I found a cool thing, instead of using a clientkillcallback you can instead use AddLocalPlayerDidDamageCallback and then check damagetype with (damageType & DF_KILLSHOT)